package org.simantics.databoard.serialization;

import org.simantics.databoard.binding.Binding;

/**
 * This is an interface that {@link Binding} may
 * implement optionally. It is used to provide
 * specialized {@link Serializer}-implementations.
 * 
 * @author Hannu Niemist&ouml;
 */
public interface SpecializedSerializerProvider {
    /** 
     * @return A specialized serializer for binding, or null.
     */
    Serializer getSpecializedSerializer();
}
